from django.db import models
from django.contrib.auth import get_user_model
from organisation.models import OrganisationsDoctorModel,OrganisationDoctorModel,TestModel,OrganisationModel,OrganisationOPDs,OPDDepartments
from .utils import SlotBookingStatusTypeEnumType, SlotBookingRecordTypeEnumType
from django.dispatch import receiver
from django.utils import timezone
from django.db.models.signals import post_save

import datetime
     
# Create your models here.

class SlotBookingRecordMediaModel(models.Model):
    record_type = models.CharField(max_length=50, choices=SlotBookingRecordTypeEnumType.choices(), null=True, blank=True,default="Not Available")
    # media = models.URLField(max_length=1000, null=True, blank=True)
    media = models.FileField(upload_to='slot_booking/SlotBookingRecordMediaModel/media/',default="organisation/CategoryModel/icon/images.png",null=True, blank=True)
    
    updated_at = models.DateTimeField(auto_now=True)
    created_at = models.DateTimeField(auto_now_add=True)

class SlotModel(models.Model):
    date = models.DateField(null=True, blank=True, auto_created=True)
    start_time = models.TimeField(null=True, blank=True, auto_created=True)
    end_time = models.TimeField(null=True, blank=True, auto_created=True)
    # organisation = models.ForeignKey(OrganisationModel, on_delete=models.CASCADE, related_name="org_modssselss",null=True)
    doctor = models.ForeignKey(OrganisationsDoctorModel, on_delete=models.CASCADE, related_name="org_modssselss",null=True)
    updated_at = models.DateTimeField(auto_now=True)
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
            return f"{self.date}"
    
class TestSlotModel(models.Model):
    date = models.DateField(null=True, blank=True, auto_created=True)
    start_time = models.TimeField(null=True, blank=True, auto_created=True)
    end_time = models.TimeField(null=True, blank=True, auto_created=True)
    # organisation = models.ForeignKey(OrganisationModel, on_delete=models.CASCADE, related_name="org_modssselss",null=True)
    test = models.ForeignKey(TestModel, on_delete=models.CASCADE, related_name="org_modssssssselss",null=True)
    updated_at = models.DateTimeField(auto_now=True)
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
            return f"{self.date}"
    

# class DoctorSlotAvailableModel(models.Model):
#     slot = models.ForeignKey(SlotModel, on_delete=models.CASCADE, related_name="SlotModels",null=True)
#     doctor = models.ForeignKey(OrganisationsDoctorModel, on_delete=models.CASCADE, related_name="DoctorSlotBookingModel_doctors")
#     organisation = models.ForeignKey(OrganisationModel, on_delete=models.CASCADE, related_name="org_models",null=True)
#     updated_at = models.DateTimeField(auto_now=True)
#     created_at = models.DateTimeField(auto_now_add=True)

#     def __str__(self):
#             return f"{self.slot}"
    


# class TestSlotAvailableModel(models.Model):
#     slot = models.ForeignKey(SlotModel, on_delete=models.CASCADE, related_name="SlotModel",null=True)
#     # end_datetime = models.DateField(null=True, blank=True, auto_created=True)
#     test = models.ForeignKey(TestModel, on_delete=models.CASCADE, related_name="TestBooking",null=True)
#     organisation = models.ForeignKey(OrganisationModel, on_delete=models.CASCADE, related_name="org_model",null=True)
#     updated_at = models.DateTimeField(auto_now=True)
#     created_at = models.DateTimeField(auto_now_add=True)
    
#     def __str__(self):
#             return f"{self.slot}"
    
class OPDSlotAvailableModel(models.Model):
    slot = models.ForeignKey(SlotModel, on_delete=models.CASCADE, related_name="SlotModelss",null=True)
    opd = models.ForeignKey(OrganisationOPDs, on_delete=models.CASCADE, related_name="OPDModel_doctorss",null=True)
    organisation = models.ForeignKey(OrganisationModel, on_delete=models.CASCADE, related_name="org_modelss",null=True)
    updated_at = models.DateTimeField(auto_now=True)
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
            return f"{self.slot}"
    
class OPDStatusModel(models.Model):
    
    name = models.CharField(max_length=50, null=True, blank=True)
    updated_at = models.DateTimeField(auto_now=True)
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
            return f"{self.slot}"

class VisitorStatus(models.Model):
    name = models.CharField(max_length=500, null=True, blank=True)
    updated_at = models.DateTimeField(auto_now=True)
    created_at = models.DateTimeField(auto_now_add=True)



class Department(models.Model):
    
    name = models.CharField(max_length=500, null=True, blank=True)
    updated_at = models.DateTimeField(auto_now=True)
    created_at = models.DateTimeField(auto_now_add=True)


class RequestedVisitorsnew(models.Model):
    user = models.ForeignKey(get_user_model(), on_delete=models.CASCADE, related_name="user_idsssss", null=True, blank=True)
    org_id = models.ForeignKey(OrganisationModel, on_delete=models.CASCADE, related_name="dept_orssg",
                                blank=True, null=True)
    patient_id = models.CharField(max_length=500, null=True, blank=True)
    patient_name = models.CharField(max_length=500, null=True, blank=True)
    ward =  models.ForeignKey(OPDDepartments, on_delete=models.CASCADE, related_name="dept_warsd",
                                blank=True, null=True)
    mobile_number = models.CharField(max_length=500, null=True, blank=True)
    visitor_name = models.CharField(max_length=500, null=True, blank=True)
    relation_with_patient = models.CharField(max_length=500, null=True, blank=True)
    visitor_status = models.ForeignKey(VisitorStatus, on_delete=models.CASCADE, related_name="depts_ossg",
                                blank=True, null=True,default= 1)
    valid_till = models.CharField(max_length=500, null=True, blank=True)
    pdf = models.FileField(upload_to='visitors/pdfs/', null=True, blank=True)
    updated_at = models.DateTimeField(auto_now=True)
    created_at = models.DateTimeField(auto_now_add=True)


class OPDBookingModel(models.Model):
    user = models.ForeignKey(get_user_model(), on_delete=models.CASCADE, related_name="user_idss", null=True, blank=True)
    patient_name = models.CharField(max_length=50, null=True, blank=True)
    gender = models.CharField(max_length=50, null=True, blank=True)
    age = models.CharField(max_length=50, null=True, blank=True)
    father_name = models.CharField(max_length=50, null=True, blank=True)
    occupation = models.CharField(max_length=50, null=True, blank=True)
    token = models.IntegerField(null=True, blank=True)
    address = models.CharField(max_length=50, null=True, blank=True)
    date = models.CharField(max_length=50, null=True, blank=True)
    mobile_number = models.CharField(max_length=50, null=True, blank=True)
    opd_dept = models.ForeignKey(OPDDepartments, on_delete=models.CASCADE, related_name="hospitals_name",null=True)
    hospital_name = models.ForeignKey(OrganisationModel, on_delete=models.CASCADE, related_name="hospitals_name",null=True)
    opd_status = models.ForeignKey(OPDStatusModel, on_delete=models.CASCADE, related_name="opd_status",null=True,default=1)
    hospital_description = models.CharField(max_length=50, null=True, blank=True)
    booking_details = models.ForeignKey(OPDSlotAvailableModel, on_delete=models.CASCADE, related_name="tests_org",null=True)
    is_booked = models.BooleanField(default=True)
    is_completed = models.BooleanField(default=False)
    recipts = models.CharField(max_length=500, null=True, blank=True)
    pdf = models.CharField(max_length=500, null=True, blank=True)
    rating = models.IntegerField(null=True, blank=True)
    review = models.CharField(max_length=50, null=True, blank=True)
    updated_at = models.DateTimeField(auto_now=True)
    created_at = models.DateTimeField(auto_now_add=True)

   
class BookingStatus(models.Model):
    name = models.CharField(max_length=50, null=True, blank=True)
    updated_at = models.DateTimeField(auto_now=True)
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
            return f"{self.slot}"
    
    
class TestBookingModel(models.Model):
    user = models.ForeignKey(get_user_model(), on_delete=models.CASCADE, related_name="user_id", null=True, blank=True)
    patient_name = models.CharField(max_length=50, null=True, blank=True)
    address = models.CharField(max_length=50, null=True, blank=True)
    mobile_number = models.CharField(max_length=50, null=True, blank=True)
    hospital_name = models.ForeignKey(OrganisationModel, on_delete=models.CASCADE, related_name="hospital_name",null=True)
    hospital_description = models.CharField(max_length=50, null=True, blank=True)
    test = models.ForeignKey(TestModel, on_delete=models.CASCADE,null=True, blank=True)
    booking_details = models.ForeignKey(TestSlotModel, on_delete=models.CASCADE, related_name="SlotModessls",null=True)
    is_booked = models.BooleanField(default=True)
    is_completed = models.ForeignKey(BookingStatus, on_delete=models.CASCADE, related_name="SlotModesslsssss",null=True,default=3)
    pdf = models.FileField(upload_to='media/recipts/',null=True, blank=True)
    rating = models.IntegerField(null=True, blank=True)
    review = models.CharField(max_length=50, null=True, blank=True)
    updated_at = models.DateTimeField(auto_now=True)
    created_at = models.DateTimeField(auto_now_add=True)

    def __str__(self):
            return f"{self.patient_name}"


class DoctorBookingModel(models.Model):
    user = models.ForeignKey(get_user_model(), on_delete=models.CASCADE, related_name="user_ids", null=True, blank=True)
    patient_name = models.CharField(max_length=50, null=True, blank=True)
    address = models.CharField(max_length=50, null=True, blank=True)
    mobile_number = models.CharField(max_length=50, null=True, blank=True)
    hospital_name = models.ForeignKey(OrganisationModel, on_delete=models.CASCADE, related_name="hospital_names", null=True)
    doctor = models.ForeignKey(OrganisationsDoctorModel, on_delete=models.CASCADE, related_name="hospital_dr", null=True)
    hospital_description = models.CharField(max_length=50, null=True, blank=True)
    booking_details = models.ForeignKey(SlotModel, on_delete=models.CASCADE, related_name="SlotModesssls", null=True)
    is_booked = models.BooleanField(default=False)  # Default to False for available slots
    is_completed = models.ForeignKey(BookingStatus, on_delete=models.CASCADE, related_name="ssss", null=True, default=3)
    pdf = models.FileField(upload_to='doctor/booking/pdf', null=True, blank=True)
    rating = models.IntegerField(null=True, blank=True)
    review = models.CharField(max_length=50, null=True, blank=True)
    updated_at = models.DateTimeField(auto_now=True)
    created_at = models.DateTimeField(auto_now_add=True)

    # class Meta:
    #     unique_together = ('user', 'is_booked')

    # def save(self, *args, **kwargs):
    #     # Check if the user already has a booked appointment
    #     if self.is_booked:
    #         existing_booking = DoctorBookingModel.objects.filter(user=self.user, is_booked=True).first()
    #         if existing_booking:
    #             # If the user has a booked appointment, prevent saving the new booking
    #             # You can handle this scenario based on your requirements, like raising an exception or not allowing the save
    #             return
    #     super().save(*args, **kwargs)
    
    

class OrganisationSlotBookingModel(models.Model):
    booking_id = models.CharField(max_length=100,null=True, blank=True)
    slot = models.ForeignKey(SlotModel, on_delete=models.CASCADE, related_name="slot_book", null=True, blank=True)
    booking_user = models.ForeignKey(get_user_model(), on_delete=models.CASCADE, related_name="Booking_user", null=True, blank=True)
    status = models.CharField(max_length=100, choices=SlotBookingStatusTypeEnumType.choices(),default="PENDING")
    updated_at = models.DateTimeField(auto_now=True)
    created_at = models.DateTimeField(auto_now_add=True)

"""
Booking Id DATETIME extract only number
2006-10-25 14:30:59 -> 20061025143059

logic
from datetime import datetime
dt = datetime.now()
id = "SLOTID"+str(dt.year)+str(dt.month)+str(dt.day)+str(dt.hour)+str(dt.minute)+str(dt.second)+str(dt.microsecond)
'SLOTID20236151726405519'
"""



    
class OrderModel(models.Model):
    booking_id = models.CharField(max_length=100,null=True,default="***********")
    user = models.ForeignKey(get_user_model(), on_delete=models.CASCADE, related_name="OrderModel_user",null=True)
    items = models.ManyToManyField(OrganisationSlotBookingModel, related_name="OrderModel_items", blank=True)
    total_paid = models.DecimalField(max_digits=10, decimal_places=2, null=True, blank=True,default=0)
    updated_at = models.DateTimeField(auto_now=True)
    created_at = models.DateTimeField(auto_now_add=True)




"""
Order Id DATETIME extract only number
2006-10-25 14:30:59 -> 20061025143059

logic
from datetime import datetime
dt = datetime.now()
id = "ORDERID"+str(dt.year)+str(dt.month)+str(dt.day)+str(dt.hour)+str(dt.minute)+str(dt.second)+str(dt.microsecond)
'ORDERID20236151726405519'
"""

# @receiver(post_save, sender=OrganisationSlotBookingModel)
# def doctor_slot_count_signals(sender, instance, **kwargs):
#     count = OrganisationSlotBookingModel.objects.filter(doctor=instance.doctor, is_booked=False).count()
#     doctor_instance = OrganisationDoctorModel.objects.get(pk=instance.doctor.pk)
#     doctor_instance.slot_is_available = count
#     doctor_instance.save()
